//Dan  7/25/2004  \DanLP115\Include\ColorBuf.inl
#pragma once

#include "ColorBuf.h"

__forceinline ColorBuf::ColorBuf(const RGBAFloat &s_color) noexcept {    // NOLINT(cppcoreguidelines-pro-type-member-init)
    red = (UBYTE)(MIN(255, fast_ftol_unsigned(s_color.Red() * MAXCOLOR + .5f)));
    green = (UBYTE)(MIN(255, fast_ftol_unsigned(s_color.Green() * MAXCOLOR + .5f)));
    blue = (UBYTE)(MIN(255, fast_ftol_unsigned(s_color.Blue() * MAXCOLOR + .5f)));
    alpha = (UBYTE)(MIN(255, fast_ftol_unsigned(s_color.Alpha() * MAXCOLOR + .5f)));
}

__forceinline RGBFloat ColorBuf::Get() const noexcept {
    return RGBFloat((float)red / MAXCOLOR, (float)green / MAXCOLOR, (float)blue / MAXCOLOR);
}

__forceinline RGBFloat ColorBuf::GetFactoredRGBFloat() const noexcept {
    return RGBFloat(red, green, blue);
}

__forceinline RGBFloat ColorBuf::GetNormalizedRGBFloat() const noexcept {
    return RGBFloat((float)red / MAXCOLOR, (float)green / MAXCOLOR, (float)blue / MAXCOLOR);
}

__forceinline RGBAFloat ColorBuf::GetNormalizedRGBAFloat() const noexcept {
    return RGBAFloat((float)red / MAXCOLOR, (float)green / MAXCOLOR, (float)blue / MAXCOLOR, (float)alpha / MAXCOLOR);
}
