//NAP  12/11/2004  \Noel120\Include\RGBFloat.inl
#pragma once

#include "RGBFloat.h"
#include "RGBHalf.h"
#include "RGBByte.h"
#include "ColorBuf.h"

//*********************************************************************
//*** RGBFloat
//*********************************************************************
__forceinline RGBFloat::RGBFloat(const RGBHalf &other) {
    *this = other.GetAsFloat();
}

__forceinline RGBFloat &RGBFloat::operator +=(const RGBHalf &other) {
    *this += other.GetAsFloat();
    return *this;
}

__forceinline RGBFloat &RGBFloat::operator *=(const RGBHalf &other) {
    *this *= other.GetAsFloat();
    return *this;
}

__forceinline RGBFloat &RGBFloat::operator=(const RGBHalf &other) {
    *this = other.GetAsFloat();
    return *this;
}

__forceinline RGBFloat::RGBFloat(const RGBByte &other) {
    *this = other.GetNormalizedRGBFloat();
//    m_red = (float)other.Red()/255.f;
//    m_green = (float)other.Green()/255.f;
//    m_blue = (float)other.Blue()/255.f;
}

__forceinline RGBFloat &RGBFloat::operator +=(const RGBByte &other) {
    *this += other.GetNormalizedRGBFloat();
//    const RGBFloat temp(other);
//    m_red += temp.m_red;
//    m_green += temp.m_green;
//    m_blue += temp.m_blue;
    return *this;
}

__forceinline RGBFloat &RGBFloat::operator=(const ColorBuf &other) {
    *this = other.GetNormalizedRGBFloat();
    return *this;
}

__forceinline RGBFloat::RGBFloat(const ColorBuf &other) {
    *this = other.GetNormalizedRGBFloat();
}

//*********************************************************************
//*** RGBAFloat
//*********************************************************************
__forceinline RGBAFloat::RGBAFloat(const RGBAHalf &other) : m_color(other.Color()), m_alpha(other.Alpha()) {}
__forceinline RGBAFloat::RGBAFloat(const RGBHalf &other) : m_color(other) {}

__forceinline void RGBAFloat::SetColor(const RGBHalf &other) {
    m_color = other.GetAsFloat();
}

__forceinline RGBAFloat::RGBAFloat(const RGBAByte &other) : m_color(other.m_color) {
    //NAP Bitmap should I use Color() instead???
    m_alpha = (float)other.Alpha() / MAXCOLOR;
}

__forceinline RGBAFloat::RGBAFloat(const ColorBuf &other) {
    *this = other.GetNormalizedRGBAFloat();
//    SetRed((float)other.red / MAXCOLOR);
//    SetGreen((float)other.green / MAXCOLOR);
//    SetBlue((float)other.blue / MAXCOLOR);
//    SetAlpha((float)other.alpha / MAXCOLOR);
}

//*********************************************************************
//*** RGBAFloat
//*********************************************************************
__forceinline YAFloat::YAFloat(const YAHalf &other) noexcept : m_luminance(other.m_luminance) {
    m_alpha = other.m_alpha;
}

__forceinline YAFloat::YAFloat(const YAByte &other) noexcept : m_luminance((float)other.m_luminance / MAXCOLOR) {
    //NAP Bitmap should I use Color() instead???
    m_alpha = (float)other.m_alpha / MAXCOLOR;
}

__forceinline YAFloat::YAFloat(const RGBAHalf &other) noexcept {
    //Compute the CIE Rec.709 luminance
    m_luminance = other.Red() * 0.2125F + other.Green() * 0.7154F + other.Blue() * 0.0721F;
    m_alpha = other.Alpha();
}

__forceinline YAFloat::YAFloat(const RGBAByte &other) noexcept {
    //Compute the CIE Rec.709 luminance
    m_luminance = ((float)other.Red() * 0.2125F + (float)other.Green() * 0.7154F + (float)other.Blue() * 0.0721F) / MAXCOLOR;
    m_alpha = (float)other.Alpha() / MAXCOLOR;
}

__forceinline YAFloat::YAFloat(const ColorBuf &other) noexcept {
    //Compute the CIE Rec.709 luminance
    m_luminance = ((float)other.red * 0.2125F + (float)other.green * 0.7154F + (float)other.blue * 0.0721F) / MAXCOLOR;
    m_alpha = 1.F;
}

__forceinline YAFloat::YAFloat(const RGBHalf &other) noexcept {
    //Compute the CIE Rec.709 luminance
    m_luminance = other.Red() * 0.2125F + other.Green() * 0.7154F + other.Blue() * 0.0721F;
    m_alpha = 1.F;
}

__forceinline YAFloat::YAFloat(const RGBByte &other) noexcept {
    //Compute the CIE Rec.709 luminance
    m_luminance = ((float)other.Red() * 0.2125F + (float)other.Green() * 0.7154F + (float)other.Blue() * 0.0721F) / MAXCOLOR;
    m_alpha = 1.F;
}
