// Dan  11/26/2001  \Dan90\Plugin\Turb\GridTurb\Custom.h
#pragma once

#include "StdAfx.h" 

#include "SDK/HPropert.h"
#include "Turbulen.h"
#include "resource.h"

class CustomTurbulence final : public Turbulence {
public:
    HIntProperty *m_octaves, *m_gridsize;
    HTypeProperty *m_celltype;

    // CONSTRUCTION/DESTRUCTION
    CustomTurbulence(HTreeObject *treeobject);
    ~CustomTurbulence() override;

    CustomTurbulence(const CustomTurbulence&) = delete;
    CustomTurbulence &operator= (const CustomTurbulence&) = delete; 
    CustomTurbulence(CustomTurbulence &&) = delete; 
    CustomTurbulence &operator=(CustomTurbulence &&) = delete; 

    // INTERFACE
    UINT GetIconID() override {
        return IDI_TURBULENCE;
    }

    UINT GetNameID() override {
        return IDS_TURBULENCENAME;
    }

    const char *GetClassName() override {
        return "Toonnation\\GridTurb";
    }

    // EVALUATION
    float Evaluate(const Vector &evalp) override;
    HProperty *GetPropertyAt(int i) override;
    float Voronoi2(const Vector *p, int style) const;
    void CalcUV(Vector e, float *u, float *v, int type) const;
    [[nodiscard]] float EvaluateHex(Vector P, float radius, float scale, float sfuzz) const;

    // CUSTOM FUNCTIONS
//    void Shift(const Vector &p, Vector &v);
};
