// KB  9/26/01  \Ken90\Plugin\Turb\GridTurb\TurbApp.h
//
#pragma once

#include <afxwin.h>
#include "resource.h"		// main symbols

#include "SDK/HPropert.h"

constexpr int MAXX = 50;
constexpr int MAXY = 50;
constexpr int MAXZ = 10;

/////////////////////////////////////////////////////////////////////////////
// CTurbApp
// See Turb.cpp for the implementation of this class
//

class CTurbApp final : public CWinApp {
public:
    enum CELLTYPE {
        CELLTYPE_XYZ=0,
        CELLTYPE_XY,
        CELLTYPE_SPHEREMAPPED,
        CELLTYPE_CYLINDERMAPPED,
        CELLTYPE_NUMBER
    };

    HIntPropertyInfo *m_octavesinfo{}, *m_gridsizeinfo{};
    HTypePropertyInfo *m_celltypeinfo{};
    TypeInfoArray m_typeinfoarray;
    short noiz_tbl[MAXX][MAXY][MAXZ]{};
    float *m_noisetable{};

    CTurbApp();
    BOOL InitInstance() override;
    int ExitInstance() override;
    void InitNoiseTable();
    [[nodiscard]] float Noise(Vector p) const;
    [[nodiscard]] float CellNoise(Vector p) const;

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CTurbApp)
    //}}AFX_VIRTUAL

    //{{AFX_MSG(CTurbApp)
    // NOTE - the ClassWizard will add and remove member functions here.
    //    DO NOT EDIT what you see in these blocks of generated code !
    //}}AFX_MSG
DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
